// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
)

// CloudEvent CloudEvent schema according to https://github.com/cloudevents/spec
type CloudEvent struct {
	// Data CloudEvent 'data' content.  The event payload. The payload depends on the type
	// and the 'schemaurl'. It is encoded into a media format which is specified by the
	// 'contenttype' attribute (e.g. application/json).
	Data *map[string]interface{} `json:"data"`

	// Datacontenttype Type: String per RFC 2046
	// Description: Content type of data value.This attribute enables data to carry any type of content, whereby format and encoding might differ from that of the chosen event format.For example, an event rendered using the JSON envelope format might carry an XML payload in data, and the consumer is informed by this attribute being set to "application/xml". The rules for how data content is rendered for different datacontenttype values are defined in the event format specifications; for example, the JSON event format defines the relationship in section 3.1.
	//
	// For some binary mode protocol bindings, this field is directly mapped to the respective protocol's content-type metadata property. Normative rules for the binary mode and the content-type metadata mapping can be found in the respective protocol
	//
	// In some event formats the datacontenttype attribute MAY be omitted.For example, if a JSON format event has no datacontenttype attribute, then it is implied that the data is a JSON value conforming to the "application/json" media type. In other words: a JSON-format event with no datacontenttype is exactly equivalent to one with datacontenttype = "application/json".
	//
	//
	// When translating an event message with no datacontenttype attribute to a different format or protocol binding, the target datacontenttype SHOULD be set explicitly to the implied datacontenttype of the source.
	//
	//
	// Constraints:
	//
	//     OPTIONAL
	//     If present, MUST adhere to the format specified in RFC 2046
	//
	// For Media Type examples see IANA Media Types
	Datacontenttype *string `json:"datacontenttype"`

	// Dataschema Type: URI
	// Description: Identifies the schema that data adheres to.Incompatible changes to the schema SHOULD be reflected by a different URI.See Versioning of Attributes in the Primer for more information.
	// Constraints:
	//     OPTIONAL
	//     If present, MUST be a non-empty URI
	Dataschema *string `json:"dataschema"`

	// Id  Identifies the event. Producers MUST ensure that source + id is unique for each distinct event. If a duplicate event is re-sent (e.g. due to a network error) it MAY have the same id. Consumers MAY assume that Events with identical source and id are duplicates.
	// Examples:
	//  An event counter maintained by the producer
	//  A UUID
	// Constraints:
	//  REQUIRED
	//  MUST be a non-empty string
	//  MUST be unique within the scope of the producer
	Id string `json:"id"`

	// Source Identifies the context in which an event happened. Often this will include information such as the type of the event source, the organization publishing the event or the process that produced the event. The exact syntax and semantics behind the data encoded in the URI is defined by the event producer.
	//
	// Producers MUST ensure that source + id is unique for each distinct event.
	//
	// An application MAY assign a unique source to each distinct producer, which makes it easy to produce unique IDs since no other producer will have the same source. The application MAY use UUIDs, URNs, DNS authorities or an application-specific scheme to create unique source identifiers.
	//
	// A source MAY include more than one producer. In that case the producers MUST collaborate to ensure that source + id is unique for each distinct event.
	//
	// Constraints:
	//
	//     REQUIRED
	//     MUST be a non-empty URI-reference
	//     An absolute URI is RECOMMENDED
	//
	// Examples
	//
	//     Internet-wide unique URI with a DNS authority.
	//         https://github.com/cloudevents
	//         mailto:cncf-wg-serverless @lists.cncf.io
	//     Universally-unique URN with a UUID:
	//         urn:uuid:6e8bc430-9c3a-11d9-9669-0800200c9a66
	//     Application-specific identifiers
	//         /cloudevents/spec/pull/123
	//         /sensors/tn-1234567/alerts
	//         1-555-123-4567
	Source string `json:"source"`

	// Specversion CloudEvents 'specversion' attribute. The version of the CloudEvents
	// specification which the event uses. This enables the interpretation of the context.
	Specversion string `json:"specversion"`

	// Subject CloudEvents 'subject' attribute. This describes the subject of the event in the context
	// of the event producer (identified by source). In publish-subscribe scenarios, a subscriber
	// will typically subscribe to events emitted by a source, but the source identifier alone
	// might not be sufficient as a qualifier for any specific event if the source context has
	// internal sub-structure.
	Subject *string `json:"subject"`

	// Time CloudEvents 'time' attribute. Timestamp of when the event happened.
	Time *time.Time `json:"time"`

	// Type CloudEvents 'type' attribute. Type of occurrence which has happened.
	// Often this attribute is used for routing, observability, policy enforcement, etc.
	Type string `json:"type"`
}

// Error The error that occured while processing this request.
type Error struct {
	Message *string `json:"message,omitempty"`
}

// BadRequestErrorResponse defines model for BadRequestErrorResponse.
type BadRequestErrorResponse struct {
	Errors []Error `json:"errors"`
}

// NotificationPublishRequest defines model for NotificationPublishRequest.
type NotificationPublishRequest struct {
	// Data CloudEvent schema according to https://github.com/cloudevents/spec
	Data CloudEvent `json:"data"`
}

// PublishNotificationJSONBody defines parameters for PublishNotification.
type PublishNotificationJSONBody struct {
	// Data CloudEvent schema according to https://github.com/cloudevents/spec
	Data CloudEvent `json:"data"`
}

// PublishNotificationJSONRequestBody defines body for PublishNotification for application/json ContentType.
type PublishNotificationJSONRequestBody PublishNotificationJSONBody

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// PublishNotificationWithBody request with any body
	PublishNotificationWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	PublishNotification(ctx context.Context, body PublishNotificationJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// SubscribeNotification request
	SubscribeNotification(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) PublishNotificationWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewPublishNotificationRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) PublishNotification(ctx context.Context, body PublishNotificationJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewPublishNotificationRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) SubscribeNotification(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewSubscribeNotificationRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewPublishNotificationRequest calls the generic PublishNotification builder with application/json body
func NewPublishNotificationRequest(server string, body PublishNotificationJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewPublishNotificationRequestWithBody(server, "application/json", bodyReader)
}

// NewPublishNotificationRequestWithBody generates requests for PublishNotification with any type of body
func NewPublishNotificationRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/publish")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewSubscribeNotificationRequest generates requests for SubscribeNotification
func NewSubscribeNotificationRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/subscribe")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// PublishNotificationWithBodyWithResponse request with any body
	PublishNotificationWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*PublishNotificationResponse, error)

	PublishNotificationWithResponse(ctx context.Context, body PublishNotificationJSONRequestBody, reqEditors ...RequestEditorFn) (*PublishNotificationResponse, error)

	// SubscribeNotificationWithResponse request
	SubscribeNotificationWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*SubscribeNotificationResponse, error)
}

type PublishNotificationResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r PublishNotificationResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r PublishNotificationResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type SubscribeNotificationResponse struct {
	Body         []byte
	HTTPResponse *http.Response
}

// Status returns HTTPResponse.Status
func (r SubscribeNotificationResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r SubscribeNotificationResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// PublishNotificationWithBodyWithResponse request with arbitrary body returning *PublishNotificationResponse
func (c *ClientWithResponses) PublishNotificationWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*PublishNotificationResponse, error) {
	rsp, err := c.PublishNotificationWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParsePublishNotificationResponse(rsp)
}

func (c *ClientWithResponses) PublishNotificationWithResponse(ctx context.Context, body PublishNotificationJSONRequestBody, reqEditors ...RequestEditorFn) (*PublishNotificationResponse, error) {
	rsp, err := c.PublishNotification(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParsePublishNotificationResponse(rsp)
}

// SubscribeNotificationWithResponse request returning *SubscribeNotificationResponse
func (c *ClientWithResponses) SubscribeNotificationWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*SubscribeNotificationResponse, error) {
	rsp, err := c.SubscribeNotification(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseSubscribeNotificationResponse(rsp)
}

// ParsePublishNotificationResponse parses an HTTP response from a PublishNotificationWithResponse call
func ParsePublishNotificationResponse(rsp *http.Response) (*PublishNotificationResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &PublishNotificationResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ParseSubscribeNotificationResponse parses an HTTP response from a SubscribeNotificationWithResponse call
func ParseSubscribeNotificationResponse(rsp *http.Response) (*SubscribeNotificationResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &SubscribeNotificationResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Publish a notification
	// (POST /publish)
	PublishNotification(w http.ResponseWriter, r *http.Request)
	// Subscribe to notifications
	// (GET /subscribe)
	SubscribeNotification(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Publish a notification
// (POST /publish)
func (_ Unimplemented) PublishNotification(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Subscribe to notifications
// (GET /subscribe)
func (_ Unimplemented) SubscribeNotification(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// PublishNotification operation middleware
func (siw *ServerInterfaceWrapper) PublishNotification(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.PublishNotification(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// SubscribeNotification operation middleware
func (siw *ServerInterfaceWrapper) SubscribeNotification(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.SubscribeNotification(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/publish", wrapper.PublishNotification)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/subscribe", wrapper.SubscribeNotification)
	})

	return r
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xZ63PbuBH/V3bYzvhuKlKSXxer05nzxU6rTvyoHfd1zgcQXIm4kAAPAKWoN/7fO4uH",
	"ROqRuO19bL7EIrCL3d8+sfgl4apulERpTTL5JdH4c4vG/qAKge7DrbJiJjizQsn7Nq+EKR/8HlrlSlqU",
	"7k/WNFXYN/zJKEnfDC+xZvQXfmZ1UyH9WTDLuv83WnE00yKZJCP/b5wMkoVGrAushJx3lo6Tl4EjDAfb",
	"VYPJZPdsvyken5TWNmYyHAYpMq7qYauroVXDsGeQCDrl4uRsPDpno/TNxRlLT89OLlI2+u4kPWEno2PG",
	"8/zkdEWbjWo1p5OHtZhrZgV+QotyyJVbbZAvUBtBKCTjbETf2vwn5DaZBH3BKlwonCMJa0VNzI5Ho/N0",
	"NE5Hxx/GZ5PR6WR09k9a9UpyVWe90zLPKdtwenkZEPsGtQ3miyD/VuMsmSS/GW7MHVQ3w7eVaovrBdmR",
	"GJALCI1FMvnRk39ci6C8Di+0rUDDtWisV/ISZMdRoPGeAsGdsqTL1uoW/UGmUdJ4QX9gRfCra62Vfghr",
	"/62TITExyeTHX5IajWFzEv+dUrBEaWGplZwnLx934IpkHV5f5jBIhMXafA1ipxP5bnRYrdlqB+1w+mvw",
	"nsoFq0QBQjatBdMSLlhkdMR13dhVF78+5a2ypZBzkIgFeSHkCBptq6WjfxkEQJ1OHdcg9ItCEBdW3XdQ",
	"m7HK4LZ8G0Lw7IBxrnRBJ1sFMSDnwpZt7uKREwUuPGwN8mSwL2n8P1n8esniUK44aMkj2nEEAc4M4EOJ",
	"4EwGDVtVihWZ+xR+QIENysKAkmBLBBLtWT9LJgv3+8jD2erqKIOpBWEAJVcFkltbBQxqLASDmdI1s7As",
	"BS9pEyEmZgILyFfEiHgedWx8BMxaLfLWInyD2TyDbZN/m/W96z/2KtlWFcuJmJLZTrzucbttWD+sGpzA",
	"o9UUEQ1qeHj3Fo5Hp+ekzdVm6wTeejYOPlAzINawYFWL2YdSmI6yKEkm43dYBZxpvQImV2vaINIAliVq",
	"zFcRWzKJw56kqcW8tFCI2Qw1zLSqwZbMEjlZjZfKoAxm9+TZO6UhwDkAFhc1ygI1FtAaF/Ylwp8f724B",
	"5QIr1WA83J8XhYW/37xfe5CQTpkBRJ/hSpq2Rk1+ICQxiG7QQyJHOtGgJRieeyH/ua6eE++nuiW0ZkpD",
	"qZYetQAQsV+LTxs8GrSyZVlvCQNMIxQ4E9J5r5O1C1F0Wi+E+b1juoZsA02XxLMzblVj5SlL0RB/g9wV",
	"2pNsnJHHQOcf/SaLGFUj5EIyvYJaFQiNVlZxVdFHsrQZeNxmAquCVC6ERm6rFdSsabAg8PzhJL0Viw2L",
	"IxOhSh0KNVrmAAwpZZXBrdOCiDY4E7euRB2z7uFFUpAdOZNUpWaqlWtw98i0D4ep9DB0gfWIbttx4zw3",
	"l/+g41QtrMWi79xiBsybKhjJMy6ZAakO83QmliCcY4naFWsfVVEUWgicnUcRJHREKJi07XmndD0nIUXS",
	"aRlMJShbooal0oWZBH5pT9KlsOU+USn5fmbO+NSRLFjlco4CJdETbVP8Ya9AG2/cZ46/EQpWM2nIneV8",
	"kyxCj3VQvo15XGXYxGPQTukd9/ZxZZme427YPv7p7un9FdmZsgR+Jj0EaR/AjkbapgtZ0Nf0vaG3/fut",
	"ksZqJqQ1k0P77+4/TO9uL9/H39MZNBqNS9U3T48fgBWUsKNw/ZziM063fuzLBjfOUajsRG82YBBhenl7",
	"2Vk03cq4r1c6UPqMq2Sx9G168n1V7+lhulPlpgVKukCEfBeaRhciLjw8ANQJZVNJHTazIq+oHDE5d9+7",
	"dBvrapxVyK2vEl2/eXqYZo+I8Fffe5EzqhlcRjczMdHca0H1hrJXrTSGquMgyQ6Z96vmzBEYSCVTpGad",
	"ZOnBTi3oVzpQL0QySVotXmMV6li3rbENuovEDO61KlqO2nhZUZqWXI9M4d0efgfC1YtWip9b9LWM8RIK",
	"YayQ3EZOU8qWRet9KCZhV1pTAiN0Z0UbglqiXSr9Cdw96FvKlpSKS7ZAb1tWI4gio47INQHGrTNDP7x8",
	"rk81PokIpxxnVZSaio0ofKWOMhlnw+sQEN6AlzEncdVKixpqsi5zpd13nJRqHER+Pzw9Ta/2+sLD9V+e",
	"pg/XbnGv5b2BessBVNIhuKDhapN54tE9h3ntVWTHLeLdZNs1tjzDZcDPlmLCt+HrvF1Sp0BXR7ibWUru",
	"1FAsRVWBkLxqi17AgGmJ1qyvA1Epz8sL49O20nMmxb9644TYRfrdoZ3wvbvx9g/gFF13dpcUKm1gVtKy",
	"z84PDNaMvMNAjqUIXYhLNJsriPv29DB1nVFo7YL9w6UnmGJvGfjVomgf80vZvdPEMBBzCSyyC4dYtcU0",
	"Cj0IlqzZJ0p2FpAZV/3ChshnemXACMmRqrJvLyILb+d+fIbC6FDfFrE16ELFDODp4dYM4Or2EVhrS6UF",
	"XULJpKynWRrbZp/YnTpcIyWTvpoi+qs2+wGLG0mO6Jkun9uSSdfkrK1JfZSzE2cGezEXbMkVJVulme9G",
	"fl3TvqZd6KUVgEM1JdXoih3HuJH8Jjeqoj4qePbD9du7m5vr26sNu+5xMTUeEmVKGVKiTZeiWBuFWLsc",
	"zHomXvUU/vIMqLuzZqKyasIln6XLeWpQL1BXFPTfV8JYk9FKJlSkeZJigdqwqlqla4luo0TkgT1kWy0n",
	"bSuKyTm+yfnpySi94CcsHY+Li/Ti/PwiHb0ZjY5HI37Bztft1eU+J+14YfeAndnWsGmrajg+PuntMiiN",
	"0mZoZTo+Pjk9O/9uyCrUfSzG6dnZGa2ntKFXBPaOl3YzfnfedHjYY+Cos7MzUvGhHb7H/N2hI2F7l92Q",
	"ZzZpszVoiIub9/iJheu4yZMajdZTxXGDrzy9gU2Yku2qFsdmX1bL79pSyeV4osljB+q39StUKApBKFK1",
	"t7xOjN+sPcGVDJ8VvnWZJdSy1LS5Pw4MR8m0UGYADNafXW/hEqxdNdTGVKvNoks7Xh/011Tf3sYKmre2",
	"c03p+CWwSkmXDvzURSrr7kDtbCa4IB0Y3UN/blnl989cTl6t5xcRiO41aN0elMyZ31lSUuPV5qmxuuW2",
	"1dg34Z7B5ld7WD/5/KJxaUvfsqJGY1ndkCGX7vq5Nte6d+lJdmCwum64C2YxdaK8RuS9w7++yP2RZebv",
	"aGoGivNWu/QdQqhkZiMzAd1puTb3Yyo7JoyttGqtuwmrnLImy0Ul7GoAjaoEXwFSa8axdhcTtLwPxCtm",
	"yDsab71oiGIz/+6nnkD5cc/s1D+W7N4dyW60FMaRhA4WBE217gJ9h+huGOuHp86cd/OQM9t6yNmeha93",
	"dl6Cton2Kb/n4Yb63/iMxXx2Qqpo5EpiLiqWf7+Q80xWyc4rj0tLbjDUe127vJ+GboMqoXEhK+Otfj1n",
	"e07eqrpWEv6o3eDspmtKeCewKiqWPyfZs5xa0BhuqAZYVamln9d1Gm/XNYf8E4ZSsfXuCmcI8kpwDI9P",
	"krnXiuun+/cwzo6TQdLqqvvK0jZVhu1wnB0PUQ59mFsHd5dtMkh6jyTZiHaqBiVrRDJJTrJRdpIMkobZ",
	"0hlwGER3431l7N6HsI3U7lYYSDaDT47SalaBZNbpRR7i9rv3gPAcftsXc/OCvjr0Kth7ZB9+4YV9+5H0",
	"eDQ6zDPsG/bf/14GyelrqA69v7oHwbaumV5tVN5ySIoENjcU8L3PH4l4uC5aJMQc91jirkG6uCwxN4p/",
	"8kP7Odpdv+rj/xgZ71jgf4Ssp/Jjt+b2JPqC2sTBdan+Cbrv8t3NGWsak4U8kIUByHBB3t0lI6om7RKm",
	"OeOfUBbp+Pg7CodsnEnRZEJN3ozejByHj2v5tgG/XqBe+Wdglqt2C+mr1vKS4A6x21Pu5ePLvwMAAP//",
	"SS+AVzQiAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
